/*
 * Copyright (c) 2005-2013, BearWare.dk
 * 
 * Contact Information:
 *
 * Bjoern D. Rasmussen
 * Bedelundvej 79
 * DK-9830 Taars
 * Denmark
 * Email: contact@bearware.dk
 * Phone: +45 20 20 54 59
 * Web: http://www.bearware.dk
 *
 * This source code is part of the TeamTalk 4 SDK owned by
 * BearWare.dk. All copyright statements may not be removed 
 * or altered from any source distribution. If you use this
 * software in a product, an acknowledgment in the product 
 * documentation is required.
 *
 */

#ifndef USERVIDEODLG_H
#define USERVIDEODLG_H

#include "common.h"

#include "ui_uservideo.h"

class UserVideoDlg : public QDialog
{
    Q_OBJECT

public:
    UserVideoDlg(int userid, int streamid, const QSize& size, 
                 QWidget * parent = 0);
    UserVideoDlg(int userid, int streamid, QWidget * parent = 0);
    ~UserVideoDlg();
    Ui::UserVideoDlg ui;

public slots:
    void slotUserUpdate(int userid, int channelid);
    void slotNewVideoFrame(int userid, int streamid);

protected:
    void initBackground();

private:
    bool m_autosize;

signals:
    void userVideoDlgClosing(int userid, int streamid);
};

#endif
