using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BearWare;

namespace TeamTalk.NET
{
    public partial class ServerPropertiesDlg : Form
    {
        TeamTalk4 ttclient;
        ServerProperties prop;

        public ServerPropertiesDlg(TeamTalk4 tt)
        {
            ttclient = tt;
            InitializeComponent();

            ttclient.GetServerProperties(out prop);
            srvnameTextBox.Text = prop.szServerName;
            passwdTextBox.Text = prop.szServerPasswd;
            maxusersNumericUpDown.Value = prop.nMaxUsers;
            motdTextBox.Text = prop.szMOTD;
            tcpportNumericUpDown.Value = prop.nTcpPort;
            udpportNumericUpDown.Value = prop.nUdpPort;
            usertimeoutNumericUpDown.Value = prop.nUserTimeout;
            autosaveCheckBox.Checked = prop.bAutoSave;

            UserRight rights = prop.uUserRights;
            channelsCheckBox.Checked = (rights & UserRight.USERRIGHT_CHANNEL_CREATION) == UserRight.USERRIGHT_CHANNEL_CREATION;
            operatorsCheckBox.Checked = (rights & UserRight.USERRIGHT_CHANNEL_OPERATORS) == UserRight.USERRIGHT_CHANNEL_OPERATORS;
            guestloginCheckBox.Checked = (rights & UserRight.USERRIGHT_GUEST_LOGIN) == UserRight.USERRIGHT_GUEST_LOGIN;
            doubleloginCheckBox.Checked = (rights & UserRight.USERRIGHT_DOUBLE_LOGIN) == UserRight.USERRIGHT_DOUBLE_LOGIN;
            viewallCheckBox.Checked = (rights & UserRight.USERRIGHT_VIEW_ALL_USERS) == UserRight.USERRIGHT_VIEW_ALL_USERS;
            bcastCheckBox.Checked = (rights & UserRight.USERRIGHT_CLIENT_BROADCAST) == UserRight.USERRIGHT_CLIENT_BROADCAST;
            chancmdCheckBox.Checked = (rights & UserRight.USERRIGHT_CHANNEL_COMMANDS) == UserRight.USERRIGHT_CHANNEL_COMMANDS;
            subscriptionsCheckBox.Checked = (rights & UserRight.USERRIGHT_SUBSCRIPTIONS) == UserRight.USERRIGHT_SUBSCRIPTIONS;
            audioCheckBox.Checked = (rights & UserRight.USERRIGHT_FORWARD_AUDIO) == UserRight.USERRIGHT_FORWARD_AUDIO;
            videoCheckBox.Checked = (rights & UserRight.USERRIGHT_FORWARD_VIDEO) == UserRight.USERRIGHT_FORWARD_VIDEO;
            desktopCheckBox.Checked = (rights & UserRight.USERRIGHT_FORWARD_DESKTOP) == UserRight.USERRIGHT_FORWARD_DESKTOP;

            versionTextBox.Text = prop.szServerVersion;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            prop.szServerName = srvnameTextBox.Text;
            prop.szServerPasswd = passwdTextBox.Text;
            prop.nMaxUsers = (int)maxusersNumericUpDown.Value;
            prop.szMOTD = motdTextBox.Text;
            prop.nTcpPort = (int)tcpportNumericUpDown.Value;
            prop.nUdpPort = (int)udpportNumericUpDown.Value;
            prop.nUserTimeout = (int)usertimeoutNumericUpDown.Value;
            prop.bAutoSave = autosaveCheckBox.Checked;

            if (channelsCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_CHANNEL_CREATION;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_CHANNEL_CREATION;

            if (operatorsCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_CHANNEL_OPERATORS;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_CHANNEL_OPERATORS;

            if (guestloginCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_GUEST_LOGIN;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_GUEST_LOGIN;

            if (doubleloginCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_DOUBLE_LOGIN;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_DOUBLE_LOGIN;

            if (viewallCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_VIEW_ALL_USERS;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_VIEW_ALL_USERS;

            if (bcastCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_CLIENT_BROADCAST;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_CLIENT_BROADCAST;

            if (chancmdCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_CHANNEL_COMMANDS;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_CHANNEL_COMMANDS;

            if (subscriptionsCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_SUBSCRIPTIONS;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_SUBSCRIPTIONS;

            if (audioCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_FORWARD_AUDIO;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_FORWARD_AUDIO;

            if (videoCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_FORWARD_VIDEO;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_FORWARD_VIDEO;

            if (desktopCheckBox.Checked)
                prop.uUserRights |= UserRight.USERRIGHT_FORWARD_DESKTOP;
            else
                prop.uUserRights &= ~UserRight.USERRIGHT_FORWARD_DESKTOP;

            ttclient.DoUpdateServer(prop);
        }
    }
}