using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BearWare;

namespace TeamTalk.NET
{
    public partial class UserInfoDlg : Form
    {
        TeamTalk4 ttclient;
        int userid;
        public UserInfoDlg(TeamTalk4 tt, int userid)
        {
            ttclient = tt;
            InitializeComponent();
            this.userid = userid;
            UpdateUser();
        }

        void UpdateUser()
        {
            User user;
            if (ttclient.GetUser(userid, out user))
            {
                useridTextBox.Text = user.nUserID.ToString();
                nicknameTextBox.Text = user.szNickname;
                usernameTextBox.Text = user.szUsername;
                statusmodeTextBox.Text = user.nStatusMode.ToString();
                statusmsgTextBox.Text = user.szStatusMsg;
                usertypeTextBox.Text = (user.uUserType & UserType.USERTYPE_ADMIN) == UserType.USERTYPE_ADMIN ? "Admin" : "Default";
                p2pTextBox.Text = ((user.uUserState & UserState.USERSTATE_P2P_CONNECTED) == UserState.USERSTATE_P2P_CONNECTED).ToString();
                versionTextBox.Text = user.szVersion;
            }
            UserStatistics stats;
            if (ttclient.GetUserStatistics(userid, out stats))
            {
                audiolossTextBox.Text = String.Format("{0}/{1}", stats.nAudioPacketsLost, stats.nAudioPacketsRecv + stats.nAudioPacketsLost);
                videolossTextBox.Text = String.Format("{0}/{1}", stats.nVideoFramesLost, stats.nVideoFramesRecv + stats.nVideoFramesLost);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            UpdateUser();
        }
    }
}